<?php
header("Access-Control-Allow-Origin: *");
header('Cache-Control: no-cache, must-revalidate'); 
header("Content-Type: text/html; charset=UTF-8");
header("HTTP/1.1 200 OK");

/**
 * Este arquivo deve ficar fora do acesso publico da API
 **/

// Bloqueia o acesso direto ao arquivo  
substr_compare($_SERVER['SCRIPT_NAME'], basename(__FILE__), -strlen(basename(__FILE__))) === 0 ? die("Acesso não permitido. #003"):FALSE;

define('BASE_URL', 'https://teseprime.bitrix24.com/rest/1/l9y03778v4r7vhzd/');

date_default_timezone_set("America/Sao_Paulo");
require('conexao.php');

/************************************************************************/
/**
 * Just to see better data output
 **/
function printarray($data){
    
    echo "<pre>";
    print_r($data);
    echo "</pre>";
    
}

/**
 * Write data to log file.
 *
 * @param mixed $data
 * @param string $title
 * @return bool
 */
function writeToLog($data, $title, $print = 1)
{
	$log = "\n------------------------\n";
	$log .= date("Y.m.d G:i:s")."\n";
	$log .= (strlen($title) > 0 ? $title : 'DEBUG')."\n";
	$log .= print_r($data, 1);
	$log .= "\n------------------------\n";
	
	if (!file_exists("../logs/".date('Y-m-d'))) {
        mkdir("../logs/".date('Y-m-d'), 0777, true);
    }

	file_put_contents("../logs/".date('Y-m-d')."/".basename($_SERVER['PHP_SELF'], '.php').".log", $log, FILE_APPEND);
	
	if($print == 1){
    	printarray($title);
    	printarray($data);
	}

	return true;
}


function pauseUs($time = 800000){
    usleep($time);
}


