<?php

require('functions.php');

function getJson($url, $array, $print = 0){
    
    global $db;
    
    global $idProcessando;
    global $obsProcessando;
    
    
    $queryData = http_build_query($array);

    $curl = curl_init();
	curl_setopt_array($curl, array(
								CURLOPT_SSL_VERIFYPEER => 0,
								CURLOPT_POST => 1,
								CURLOPT_HEADER => 0,
								CURLOPT_RETURNTRANSFER => 1,							
								CURLOPT_URL => BASE_URL.$url,
								CURLOPT_POSTFIELDS => $queryData,
								));
	$result = curl_exec($curl);
	curl_close($curl);

	$result = json_decode($result, 1);
	
// 	if($print == 1){
	    printArray($url);
	    printArray($array);
	    printArray($result);

// 	}
	
	if (array_key_exists('error', $result)){

        echo "Error: ".$result['error_description']."<br/>";
        
        updateStatus($idProcessando, $db, 3, $obsProcessando, "Error: ".$result['error_description']);

        writeToLog($result, "Error: ");
        
        exit();

    }
	

	
	pauseUs();
	
	return $result;
    
}




function getContact($cpfBusca, $print = 0){
    
    $queryUrl = "crm.contact.list";

    $queryArray = array("filter" => array(
                                    "=UF_CRM_1589202720035" => $cpfBusca,
                        ),
                        "order" => array("ID", "ASC"),
                        "select" => array('*', 'UF_*', 'PHONE', 'EMAIL')
                        );  

    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
}



// Chamada da função
// "UF_CRM_61EEF0C9C15A3"  => getField('UF_CRM_61EEF0C9C15A3', $dados['estado'], 'contact', 0, MB_CASE_UPPER), o MB_CASE_UPPER (TUDO MAIÚSCULO) - MB_CASE_TITLE (Primeia Letra Maiúscula)
function getField($field, $item, $entity, $print = 0){
    
    // $item = trim(mb_convert_case($item, $case, 'UTF-8'));
    
    printArray($field);
    printArray($item);
    
    if(trim($item) != ''){
    
        $queryUrl = "crm.{$entity}.userfield.list";
    
        $array = array(
                "filter" => array(
                        "FIELD_NAME" => $field
                    )
            );
    
        $result = getJson($queryUrl, $array, $print);
        
        if(isset($result['result'][0]['LIST'][0]['ID'])){
            foreach($result['result'][0]['LIST'] as $key => $value){
                
                $itens[$key] = trim($value['VALUE']);
                $itensId[$key] = $value['ID'];
                        
            }
            $found = array_search(trim($item), $itens);
        }else{
            $found = false;
        }
        
        if($found === false){
    
            updateField($result['result'][0]['ID'], trim($item), $entity, $print);
            $newItem = getField($field,  trim($item), $entity, $print);
            
            return $newItem;
    
        }else{
    
            return $itensId[$found];
        }
    }else{
        // getField($field, 'Não Informado', $entity, $print);
        return "";
    }

}

function updateField($fieldId, $item, $entity, $print =0){
    
    $queryUrl = "crm.{$entity}.userfield.update";
    
    $array = array(
            "ID" => $fieldId,
            "fields" => array(
                        "LIST" => array(array(
                                     "VALUE" => $item
                                    ))
                        ),
        );

    $result = getJson($queryUrl, $array, $print);
    sleep(2);
    
}


function addFeed($company, $mensagem, $entity, $print = 1){
    
    $queryUrl = "crm.livefeedmessage.add";

    $queryArray = array(
								 'fields' => array(

								 	"POST_TITLE" => $company,
								 	"MESSAGE" => $mensagem,
								 	"ENTITYTYPEID" =>  $entity,
								 	"ENTITYID" => $company
								 
								 ),
				);  

    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
    
}



function getRequestBd($db){
    
    $dados = array();

    $sql = $db->prepare("SELECT * FROM ecommerce_hom where status = 0 order by id limit 10");
    $sql->execute();
    
    if($sql->rowCount() > 0){
        
        $dados = $sql->fetchAll();
        
        return $dados;
        
    }else{
        
        echo "Sem Atualizações";
        exit();
        
    }
}

function checkStatus($id, $db, $status){
    
    $query = "SELECT * FROM ecommerce_hom where status = 0 and id = {$id}";
    
    printArray($query);
    
    $sql = $db->prepare($query);
    $sql->execute();
    
    if($sql->rowCount() > 0){
        
        return true;
        
    }else{
        
        return false;
        
    }
    
}

function updateStatus($id, $db, $status, $oldObs, $newObs = null){
    
    if(isset($newObs)){
        $obs = unserialize($oldObs);
        array_push($obs, $newObs);
        $obs = serialize($obs);
    }else{
        $obs = $oldObs;
    }

    $query = "update ecommerce_hom set status = {$status}, updated=CURRENT_TIMESTAMP(), obs = '".str_replace("'", "-", $obs)."' where id = ".$id;

    printArray($query);
    
    $sql = $db->prepare($query);
    $sql->execute();
    
}

function adjustPhone($phone){
    
    printArray($phone);
    
    if(!isset($phone) || $phone == ''){
        
        return '';
        
    }
    
    $phone = trim(preg_replace('/[^0-9]/', '', $phone));
    
    if(substr($phone, 0,1) != '+'){
       $phone = '+'.$phone;
    }
    
    printArray($phone);
    
    $phone = str_replace("+55", "", $phone);
    $phone = str_replace("+", "", $phone);
    
    printArray($phone);
    
    if(substr($phone, 0,1) != '0'){
        $phone = '+55'.$phone;
    }else{
        $phone = '+55'.substr($phone, 1);
    }
    
    printArray($phone);
    

    if(strlen($phone) == 14 ){
        return $phone;
        
    }elseif(strlen($phone) == 13 ){
        
        if(substr($phone, 0,1) == '+'){
            
            if(substr($phone, 5,1) == '7' || substr($phone, 5,1) == '8' || substr($phone, 5,1) == '9'){
                
                return substr($phone, 0,5).'9'.substr($phone, 5);
                
            }else{
            
                return $phone;
                
            }
            
        }else{
            return '+'.$phone;
        }
        
    }elseif(strlen($phone) < 13 ){
        
        if(substr($phone, 0,3) != '+55'){
            
            $phone = str_replace("+", "", $phone);
            
            if(strlen($phone) == 11){
                
                return '+55'.$phone;
                
            }elseif(strlen($phone) < 11){
                if(substr($phone, 2,1) == '7' || substr($phone, 2,1) == '8' || substr($phone, 2,1) == '9'){
                    return '+55'.substr($phone, 0,2).'9'.substr($phone, 2);
                }else{
                    return '+55'.$phone;
                }
            }else{
            
                return $phone;
            
            }
        }else{
            
            return $phone;
            
        }
        
        
        
    }else{    
        return $phone;
    }
    
}

function validateEmail($email) {
    
    $email = explode(";", $email)[0];
    
    if(!filter_var($email, FILTER_VALIDATE_EMAIL) && trim($email) != '') {

        echo "E-mail ".$email." inválido";
        writeToLog("E-mail ".$email." inválido", "ERRO ".date('Y-m-d H:i:s'));

        return "";
    }else{
        return $email;
    }
}

function phonesUpdate($oldPhones, $newPhone, $type = 'WORK', $phonEmail = 'PHONE'){
    
    printArray($oldPhones);
    
    if(isset($newPhone) && $newPhone != ''){
        
        if($phonEmail == 'PHONE'){
    
            $found = false;
            foreach($oldPhones as $key => $value){
                if(adjustPhone($value['VALUE']) == adjustPhone($newPhone)){
                    $found = true; 
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }else{
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => adjustPhone($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
        }elseif($phonEmail == 'EMAIL'){
            
            $found = false;
            foreach($oldPhones as $key => $value){
                if($value['VALUE'] == validateEmail($newPhone)){
                    $found = true;        
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => validateEmail($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
        }else{
            
            $found = false;
            foreach($oldPhones as $key => $value){
                if($value['VALUE'] == $newPhone){
                    $found = true;        
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => $newPhone
                    );
                
            }
            
            return $oldPhones;
            
        }
        
    }else{
        return $oldPhones;
    }
    
}

function getUltima($dta){
    
    // substr(string $string, int $offset, ?int $length = null)  AAAAMMDD
    
    return substr($dta, 0, 4)."-".substr($dta, 4, 2)."-".substr($dta, 6, 2);
    
}


function formatar_cpf_cnpj($doc) {

    $doc = preg_replace("/[^0-9]/", "", $doc);
    $qtd = strlen($doc);

    if ($qtd >= 11) {

        if ($qtd === 11) {

            $docFormatado = substr($doc, 0, 3).
            '.'.
            substr($doc, 3, 3).
            '.'.
            substr($doc, 6, 3).
            '.'.
            substr($doc, 9, 2);
        } else {
            $docFormatado = substr($doc, 0, 2).
            '.'.
            substr($doc, 2, 3).
            '.'.
            substr($doc, 5, 3).
            '/'.
            substr($doc, 8, 4).
            '-'.
            substr($doc, -2);
        }

        return $docFormatado;

    } else {
        return 'Documento invalido';
    }
}


function getName($nome, $parte) {
    
        $nome = str_replace('(', '', str_replace(')', '', $nome));

	    $parts = array();

	    while ( strlen( trim($nome)) > 0 ) {
	        $nome = trim($nome);
	        $string = preg_replace('#.*\s([\w-]*)$#', '$1', $nome);
	        $parts[] = $string;
	        $nome = trim( preg_replace('#'.$string.'#', '', $nome ) );
	    }

	    if (empty($parts)) {
	        return false;
	    }

	    $parts = array_reverse($parts);
	    $nome = array();
	    $nome['first_nomealuno'] = $parts[0];

	    $nome['middle_nomealuno'] = (isset($parts[2])) ? $parts[1] : '';
	    $nome['last_nomealuno'] = (isset($parts[2])) ? $parts[2] : ( isset($parts[1]) ? $parts[1] : '');

	    if($parte == 1){

	        return reset($parts);

	    }elseif($parte == 2){
	        $middle = '';

	        if(count($parts)>2){

	            for ($i=1; $i <= count($parts)-2; $i++) { 
	                $middle = $middle." ".$parts[$i];
	            }
	            return $middle;


	        }else{
	            return '';
	        }

	    }elseif($parte == 3){

	        return end($parts);

	    }else{
	        return '';
	    }

}

function addDeal($fields, $print = 0){
    
    $queryUrl = "crm.deal.add";

    $queryArray = array("fields" => $fields);  
                        
    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
	
}

function updateDeal($fields, $id, $print = 0){
    
    if(isset($id) && $id > 0 ){
        $queryUrl = "crm.deal.update";
    
        $queryArray = array("fields" => $fields, "ID" => $id);  
        
        printArray($queryArray);
        
        $result = getJson($queryUrl, $queryArray, $print);
    
    	return $result;
    }else{
        exit();
    }
	
}

function getDealByFilterSim($filter, $print){
    
    printArray('getDealByFilter - '.'pedido_id'.$filter);
    
    if(isset($filter) && $filter != ''){
        $queryUrl = "crm.deal.list";

        $fields = Array('filter' => array(
                  
                                '=UF_CRM_1590676790' => trim($filter),
                                "=CATEGORY_ID" => 14,
                                "=SOURCE_ID" => "UC_S13KZR"
                            ),
                        'SELECT' => array('UF_*', '*')
                        );
        
        $result = getJson($queryUrl, $fields, $print);
        
        return $result;
    }
    
}

function getDealByFilterMat($filter, $print){
    
    printArray('getDealByFilter - '.'pedido_id'.$filter);
    
    if(isset($filter) && $filter != ''){
        $queryUrl = "crm.deal.list";

        $fields = Array('filter' => array(
                  
                                '=UF_CRM_1590676790' => trim($filter),
                                "=CATEGORY_ID" => 4,
                                "=SOURCE_ID" => "UC_S13KZR"
                            ),
                        'SELECT' => array('UF_*', '*')
                        );
        
        $result = getJson($queryUrl, $fields, $print);
        
        return $result;
    }
    
}

function getDealByFilter($filter, $print){
    
    printArray('getDealByFilter - '.'pedido_id'.$filter);
    
    if(isset($filter) && $filter != ''){
        $queryUrl = "crm.deal.list";

        $fields = Array('filter' => array(
                  
                                '=UF_CRM_1590676790' => trim($filter),
                                "=CATEGORY_ID" => 0,
                                "=SOURCE_ID" => "UC_S13KZR"
                            ),
                        'SELECT' => array('UF_*', '*')
                        );
        
        $result = getJson($queryUrl, $fields, $print);
        
        return $result;
    }
    
}

function getContactById($customerId, $print = 0){
    
    $queryUrl = "crm.contact.list";

    $queryArray = array("filter" => array(
                                    "=UF_CRM_1672173391546" => $customerId,
                        ),
                        "order" => array("ID", "ASC"),
                        "select" => array('*', 'UF_*', 'PHONE', 'EMAIL')
                        );  

    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
}

function getFormaPagto($forma){
    
    if(strpos($forma, "pix")){
        return "PIX";
    }elseif(strpos($forma, "cielo")){
        return "Cielo";
    }else{
        return "";
    }
}

function getStatus($forma){
    
    if($forma == "pending"){
        return "Pendente";
    }else{
        return $forma;
    }
}



/***********************************************************************/

if($_REQUEST['tkn'] == '4rbJsuDdw2X0GX8'){
    
    $dados = getRequestBd($db);
    
    foreach($dados as $key => $value){
        
        printArray($value);
        
        $idProcessando = $value['id'];
        $obsProcessando = $value['obs'];
        
        if(checkStatus($value['id'], $db, 0)){
            updateStatus($value['id'], $db, 1, $value['obs']);
        }else{
            continue;
        }
        
        if($request == $value['data']){
            updateStatus($value['id'], $db, 3, $value['obs'], "REPETIDO");
            continue;
        }else{
            $request = $value['data'];
        }
        
        $data = unserialize($value['data']);
        
        $data['id'] = $data['id']+500000;
        
        printArray($data);

        $deal = getDealByFilter($data['id'], 1);
        
        $contact = getContactById($data['customer_id'], 1);
        
        if($contact['total'] == 0){
            
            updateStatus($value['id'], $db, 0, $value['obs'], 'Contato não encontrado');
            
            exit();
            
        }else{
            $contact = $contact['result'][0]['ID'];
        }
        
        $tipoProduto = array();
        $produtosEcommerce = array();
        $valorProd = 0;
        $valorFret = 0;
        foreach($data['line_items'] as $keyProd => $valueProd){
            
            $valorProd = $valorProd + $valueProd['total'];
            
            foreach($valueProd['meta_data'] as $keyMeta => $valueMeta){
                
                if(trim($valueMeta['key']) == "simulado" && !in_array(4262, $tipoProduto)){
                    
                    $tipoProduto[] = 4262; //Simulado
                    
                    $simuladoNome = $valueMeta['display_value'];
                    
                    printArray($valueMeta['display_value']);
                    
                }
                
            }
            
            if(strpos(strtoupper($valueProd['name']), "PACK") !== false && !in_array(4270, $tipoProduto)){
                $tipoProduto[] = 4270; //Pack
            }
            
            if(strpos(strtoupper($valueProd['name']), "LIVRO") !== false && !in_array(4268, $tipoProduto)){
                $tipoProduto[] = 4268; //Livro
            }
            
            if(strpos(strtoupper($valueProd['name']), "APOSTILA") !== false && !in_array(4264, $tipoProduto)){
                $tipoProduto[] = 4264; //Apostila
            }
            
            if(strpos(strtoupper($valueProd['name']), "CURSO") !== false && !in_array(4266, $tipoProduto)){
                $tipoProduto[] = 4266; //Curso
            }
            
            
            $produtosEcommerce[] = getField('UF_CRM_1682593749', $valueProd['name'],'deal');
            
            
        }
        
        foreach($data['shipping_lines'] as $keyProd => $valueProd){
            
            $valorFret = $valorFret + $valueProd['total'];
            
        }
        
        printArray($tipoProduto);
        
        $statusPedido = array(
                            'pending' => "Pendente",
                            'processing' => "Processando",
                            'on-hold' => 'Aguardando Pagamento',
                            'cancelled' => "Cancelado",
                            'refunded' => "Reembolsado",
                            'failed' => "ERRO",
                            'sent' => "Concluído");
        
        
        $fields = array(
                'UF_CRM_1590676790'     => $data['id'],
                'TITLE'                 => "ePedido ".$data['id'],
                'CONTACT_ID'            => $contact,
                'SOURCE_ID'             => "UC_S13KZR", // E-commerce
                
                'OPPORTUNITY'           => $data['total'], //number_format($data['total'], 2, ",", "")."|".$data['currency'],

                "UF_CRM_1626517884"     => getField('UF_CRM_1626517884', getStatus($statusPedido[$data['status']]),'deal'),
                
                "UF_CRM_1626606112239"  => getField('UF_CRM_1626606112239', getFormaPagto($data['payment_method']),'deal'),
                
                'UF_CRM_1590676123198'  => $data['date_created'],
                'UF_CRM_1626519503600'  => $data['date_modified'],
                
                'UF_CRM_1627214217638'  => 0,
                'UF_CRM_1680618653'     => $tipoProduto,
                'UF_CRM_1682593749'     => $produtosEcommerce,
                
                /* Simulado */
                // 'UF_CRM_1600102383'     => getField('UF_CRM_1600102383', $simuladoNome,'deal'),
                // 'UF_CRM_1626611815352'  => getField('UF_CRM_1600102383', 'Simulado','deal'),
                
                'UF_CRM_1682594330574'  => $valorProd,
                'UF_CRM_1650646909336'  => $valorFret,
                
                "UF_CRM_1682594474299"  => getField('UF_CRM_1682594474299', $data['shipping_lines'][0]['method_title'],'deal'),
                
        );
        
        printArray($fields);
        
        // exit();
        
        if($deal['total'] == 0){
            
            $deal['ID'] = addDeal($fields, 1)['result'];

        }else{
            
            printArray($deal[0]);
            
            $deal['upd'] = updateDeal($fields, $deal['result'][0]['ID'], 1)['result'];
            $deal['ID'] = $deal['result'][0]['ID'];
                
        }
        
        
        
        printArray($fields);
        
        
        $mensagem = '[B]Pedido com dados atualizados vindos do E-Commerce.[/B]';

        addFeed($deal['ID'], $mensagem, '2');
        
        
        /* Se houver simulado e o pedido estiver pago, cria/atualiza o card em "monitoria de simulado" */
        
        if($data['status'] == 'sent'){ // PAGO
        
            $fields['UF_CRM_1626610167607'] = 1;
        
            if(in_array(4262, $tipoProduto)){ // SIMULADO COMPRADO
                
                $dealSim = getDealByFilterSim($data['id'], 1);
                
                $fields['CATEGORY_ID'] = 14;
                $fields['TITLE'] = "ePedido ".$data['id']." - ".$simuladoNome;
                $fields['UF_CRM_1600102383'] = getField('UF_CRM_1600102383', $simuladoNome,'deal');
                $fields['UF_CRM_1626611815352'] = getField('UF_CRM_1600102383', 'Simulado','deal');
                
                if($dealSim['total'] == 0){
            
                    $dealSim['ID'] = addDeal($fields, 1)['result'];
        
                }else{
                    
                    $dealSim['upd'] = updateDeal($fields, $dealSim['result'][0]['ID'], 1)['result'];
                        
                }
            }
            
            if(in_array(4264, $tipoProduto) || in_array(4266, $tipoProduto) || in_array(4268, $tipoProduto) || in_array(4270, $tipoProduto)){ // OUTROS MATERIAIS
                
                $dealMat = getDealByFilterMat($data['id'], 1);
                
                $fields['CATEGORY_ID'] = 4;
                $fields['TITLE'] = "ePedido ".$data['id']." - Materiais";
                $fields['UF_CRM_1600102383'] = getField('UF_CRM_1600102383', $simuladoNome,'deal');
                $fields['UF_CRM_1626611815352'] = getField('UF_CRM_1600102383', 'Simulado','deal');
                
                if($dealMat['total'] == 0){
            
                    $dealMat['ID'] = addDeal($fields, 1)['result'];
        
                }else{
                    
                    $dealMat['upd'] = updateDeal($fields, $dealMat['result'][0]['ID'], 1)['result'];
                        
                }
            }
            
        }
        
        updateStatus($value['id'], $db, 2, $value['obs'], 'OK');

    }

}

        



















