<?php

require('functions.php');


function getJson($url, $array, $print = 0){
    
    global $db;
    
    global $idProcessando;
    global $obsProcessando;
    
    
    $queryData = http_build_query($array);

    $curl = curl_init();
	curl_setopt_array($curl, array(
								CURLOPT_SSL_VERIFYPEER => 0,
								CURLOPT_POST => 1,
								CURLOPT_HEADER => 0,
								CURLOPT_RETURNTRANSFER => 1,							
								CURLOPT_URL => BASE_URL.$url,
								CURLOPT_POSTFIELDS => $queryData,
								));
	$result = curl_exec($curl);
	curl_close($curl);

	$result = json_decode($result, 1);
	
	if (array_key_exists('error', $result)){

        echo "Error: ".$result['error_description']."<br/>";
        
        updateStatus($idProcessando, $db, 3, $obsProcessando, "Error: ".$result['error_description']);

        writeToLog($result, "Error: ");
        
        exit();

    }
	
	if($print == 1){
	    printArray($url);
	    printArray($array);
	    printArray($result);

	}
	
	pauseUs();
	
    return $result;
    
}




function getContact($cpfBusca, $print = 0){
    
    $queryUrl = "crm.contact.list";

    $queryArray = array("filter" => array(
                                    "=UF_CRM_1589202720035" => $cpfBusca,
                        ),
                        "order" => array("ID", "ASC"),
                        "select" => array('*', 'UF_*', 'PHONE', 'EMAIL')
                        );  

    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
}



// Chamada da função
// "UF_CRM_61EEF0C9C15A3"  => getField('UF_CRM_61EEF0C9C15A3', $dados['estado'], 'contact', 0, MB_CASE_UPPER), o MB_CASE_UPPER (TUDO MAIÚSCULO) - MB_CASE_TITLE (Primeia Letra Maiúscula)
function getField($field, $item, $entity, $print = 0){
    
    // $item = trim(mb_convert_case($item, $case, 'UTF-8'));
    
    printArray($field);
    printArray($item);
    
    if(trim($item) != ''){
    
        $queryUrl = "crm.{$entity}.userfield.list";
    
        $array = array(
                "filter" => array(
                        "FIELD_NAME" => $field
                    )
            );
    
        $result = getJson($queryUrl, $array, $print);
        
        if(isset($result['result'][0]['LIST'][0]['ID'])){
            foreach($result['result'][0]['LIST'] as $key => $value){
                
                $itens[$key] = trim($value['VALUE']);
                $itensId[$key] = $value['ID'];
                        
            }
            $found = array_search(trim($item), $itens);
        }else{
            $found = false;
        }
        
        if($found === false){
    
            updateField($result['result'][0]['ID'], trim($item), $entity, $print);
            $newItem = getField($field,  trim($item), $entity, $print);
            
            return $newItem;
    
        }else{
    
            return $itensId[$found];
        }
    }else{
        // getField($field, 'Não Informado', $entity, $print);
        return "";
    }

}

function updateField($fieldId, $item, $entity, $print =0){
    
    $queryUrl = "crm.{$entity}.userfield.update";
    
    $array = array(
            "ID" => $fieldId,
            "fields" => array(
                        "LIST" => array(array(
                                     "VALUE" => $item
                                    ))
                        ),
        );

    $result = getJson($queryUrl, $array, $print);
    sleep(2);
    
}


function addFeed($company, $mensagem, $entity, $print = 1){
    
    $queryUrl = "crm.livefeedmessage.add";

    $queryArray = array(
								 'fields' => array(

								 	"POST_TITLE" => $company,
								 	"MESSAGE" => $mensagem,
								 	"ENTITYTYPEID" =>  $entity,
								 	"ENTITYID" => $company
								 
								 ),
				);  

    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
    
}



function getRequestBd($db){
    
    $dados = array();

    $sql = $db->prepare("SELECT * FROM ecommerce_hom where status = 0 and entity='user' order by id limit 20");
    $sql->execute();
    
    if($sql->rowCount() > 0){
        
        $dados = $sql->fetchAll();
        
        return $dados;
        
    }else{
        
        echo "Sem Atualizações";
        exit();
        
    }
}

function checkStatus($id, $db, $status){
    
    $query = "SELECT * FROM ecommerce_hom where status = 0 and id = {$id}";
    
    printArray($query);
    
    $sql = $db->prepare($query);
    $sql->execute();
    
    if($sql->rowCount() > 0){
        
        return true;
        
    }else{
        
        return false;
        
    }
    
}

function updateStatus($id, $db, $status, $oldObs, $newObs = null){
    
    if(isset($newObs)){
        $obs = unserialize($oldObs);
        array_push($obs, $newObs);
        $obs = serialize($obs);
    }else{
        $obs = $oldObs;
    }

    $query = "update ecommerce_hom set status = {$status}, updated=CURRENT_TIMESTAMP(), obs = '".str_replace("'", "-", $obs)."' where id = ".$id;

    printArray($query);
    
    $sql = $db->prepare($query);
    $sql->execute();
    
}

function adjustPhone($phone){
    
    printArray($phone);
    
    if(!isset($phone) || $phone == ''){
        
        return '';
        
    }
    
    $phone = trim(preg_replace('/[^0-9]/', '', $phone));
    
    if(substr($phone, 0,1) != '+'){
       $phone = '+'.$phone;
    }
    
    printArray($phone);
    
    $phone = str_replace("+55", "", $phone);
    $phone = str_replace("+", "", $phone);
    
    printArray($phone);
    
    if(substr($phone, 0,1) != '0'){
        $phone = '+55'.$phone;
    }else{
        $phone = '+55'.substr($phone, 1);
    }
    
    printArray($phone);
    

    if(strlen($phone) == 14 ){
        return $phone;
        
    }elseif(strlen($phone) == 13 ){
        
        if(substr($phone, 0,1) == '+'){
            
            if(substr($phone, 5,1) == '7' || substr($phone, 5,1) == '8' || substr($phone, 5,1) == '9'){
                
                return substr($phone, 0,5).'9'.substr($phone, 5);
                
            }else{
            
                return $phone;
                
            }
            
        }else{
            return '+'.$phone;
        }
        
    }elseif(strlen($phone) < 13 ){
        
        if(substr($phone, 0,3) != '+55'){
            
            $phone = str_replace("+", "", $phone);
            
            if(strlen($phone) == 11){
                
                return '+55'.$phone;
                
            }elseif(strlen($phone) < 11){
                if(substr($phone, 2,1) == '7' || substr($phone, 2,1) == '8' || substr($phone, 2,1) == '9'){
                    return '+55'.substr($phone, 0,2).'9'.substr($phone, 2);
                }else{
                    return '+55'.$phone;
                }
            }else{
            
                return $phone;
            
            }
        }else{
            
            return $phone;
            
        }
        
        
        
    }else{    
        return $phone;
    }
    
}

function validateEmail($email) {
    
    $email = explode(";", $email)[0];
    
    if(!filter_var($email, FILTER_VALIDATE_EMAIL) && trim($email) != '') {

        echo "E-mail ".$email." inválido";
        writeToLog("E-mail ".$email." inválido", "ERRO ".date('Y-m-d H:i:s'));

        return "";
    }else{
        return $email;
    }
}

function phonesUpdate($oldPhones, $newPhone, $type = 'WORK', $phonEmail = 'PHONE'){
    
    printArray($oldPhones);
    
    if(isset($newPhone) && $newPhone != ''){
        
        if($phonEmail == 'PHONE'){
    
            $found = false;
            foreach($oldPhones as $key => $value){
                if(adjustPhone($value['VALUE']) == adjustPhone($newPhone)){
                    $found = true; 
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }else{
                    
                    $oldPhones[$key]['VALUE'] = adjustPhone($value['VALUE']);
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => adjustPhone($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
        }elseif($phonEmail == 'EMAIL'){
            
            $found = false;
            foreach($oldPhones as $key => $value){
                if($value['VALUE'] == validateEmail($newPhone)){
                    $found = true;        
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => validateEmail($newPhone)
                    );
                
            }
            
            return $oldPhones;
            
        }else{
            
            $found = false;
            foreach($oldPhones as $key => $value){
                if($value['VALUE'] == $newPhone){
                    $found = true;        
                }
            }
            
            if($found == false){
                
                $oldPhones[] = array(
                                'VALUE_TYPE' => $type,
                                'VALUE'      => $newPhone
                    );
                
            }
            
            return $oldPhones;
            
        }
        
    }else{
        return $oldPhones;
    }
    
}

function getUltima($dta){
    
    // substr(string $string, int $offset, ?int $length = null)  AAAAMMDD
    
    return substr($dta, 0, 4)."-".substr($dta, 4, 2)."-".substr($dta, 6, 2);
    
}


function formatar_cpf_cnpj($doc) {

    $doc = preg_replace("/[^0-9]/", "", $doc);
    $qtd = strlen($doc);

    if ($qtd >= 11) {

        if ($qtd === 11) {

            $docFormatado = substr($doc, 0, 3).
            '.'.
            substr($doc, 3, 3).
            '.'.
            substr($doc, 6, 3).
            '.'.
            substr($doc, 9, 2);
        } else {
            $docFormatado = substr($doc, 0, 2).
            '.'.
            substr($doc, 2, 3).
            '.'.
            substr($doc, 5, 3).
            '/'.
            substr($doc, 8, 4).
            '-'.
            substr($doc, -2);
        }

        return $docFormatado;

    } else {
        return 'Documento invalido';
    }
}


function getName($nome, $parte) {
    
        $nome = str_replace('(', '', str_replace(')', '', $nome));

	    $parts = array();

	    while ( strlen( trim($nome)) > 0 ) {
	        $nome = trim($nome);
	        $string = preg_replace('#.*\s([\w-]*)$#', '$1', $nome);
	        $parts[] = $string;
	        $nome = trim( preg_replace('#'.$string.'#', '', $nome ) );
	    }

	    if (empty($parts)) {
	        return false;
	    }

	    $parts = array_reverse($parts);
	    $nome = array();
	    $nome['first_nomealuno'] = $parts[0];

	    $nome['middle_nomealuno'] = (isset($parts[2])) ? $parts[1] : '';
	    $nome['last_nomealuno'] = (isset($parts[2])) ? $parts[2] : ( isset($parts[1]) ? $parts[1] : '');

	    if($parte == 1){

	        return reset($parts);

	    }elseif($parte == 2){
	        $middle = '';

	        if(count($parts)>2){

	            for ($i=1; $i <= count($parts)-2; $i++) { 
	                $middle = $middle." ".$parts[$i];
	            }
	            return $middle;


	        }else{
	            return '';
	        }

	    }elseif($parte == 3){

	        return end($parts);

	    }else{
	        return '';
	    }

}

function addContact($fields, $print = 0){
    
    $queryUrl = "crm.contact.add";

    $queryArray = array("fields" => $fields);  
                        
    $result = getJson($queryUrl, $queryArray, $print);

	return $result;
	
}

function updateContact($fields, $id, $print = 0){
    
    if(isset($id) && $id >0 ){
        $queryUrl = "crm.contact.update";
    
        $queryArray = array("fields" => $fields, "ID" => $id);  
        
        printArray($queryArray);
        
        $result = getJson($queryUrl, $queryArray, $print);
    
    	return $result;
    }else{
        exit();
    }
	
}

function arrayToString($array, $indent = 0) {
    $result = '';

    foreach ($array as $key => $value) {
        // Adicione identação com base no nível atual
        $result .= str_repeat('    ', $indent);

        // Adicione a chave como label da linha
        $result .= $key . ': ';

        if (is_array($value)) {
            // Se o valor for um array, chame recursivamente a função
            $result .= "\n" . arrayToString($value, $indent + 1);
        } else {
            // Se o valor não for um array, adicione-o à linha
            $result .= $value;
        }

        // Adicione uma quebra de linha após cada linha
        $result .= "\n";
    }

    return $result;
}



/***********************************************************************/

if($_REQUEST['tkn'] == '4rbJsuDdw2X0GX8'){
    
    $dados = getRequestBd($db);

    foreach($dados as $key => $value){
        
        printArray($value);
        
        $idProcessando = $value['id'];
        $obsProcessando = $value['obs'];
        
        if(checkStatus($value['id'], $db, 0)){
            updateStatus($value['id'], $db, 1, $value['obs']);
        }else{
            continue;
        }
        
        if($request == $value['data']){
            updateStatus($value['id'], $db, 3, $value['obs'], "REPETIDO");
            continue;
        }else{
            $request = $value['data'];
        }
        
        $data = unserialize($value['data']);
        
        printArray($data);
        
        foreach($data['meta_data'] as $keyMd => $valueMd){
            
            $data['meta_data'][$valueMd['key']] = $valueMd['value'];
            
        }
        
        if($data['meta_data']['_customer_is_foreigner'] == 'Não' || !isset($data['meta_data']['_customer_is_foreigner'])){
            $cpfBusca = $data['billing']['cpf'];
        }elseif($data['meta_data']['_customer_is_foreigner'] == 'Sim'){
            $cpfBusca = $data['meta_data']['_customer_passport'];
        }
        
        if(!isset($cpfBusca) || $cpfBusca == ''){
            echo "erro sem CPF";
            
            updateStatus($value['id'], $db, 3, $value['obs'], 'ERRO SEM CPF');
            
            exit();
        }
        
        //Definir chave de busca
        $contact = getContact($cpfBusca, 1);
        
        //Definir 
        $fields = array(
                    'NAME'                  => $data['first_name'],
                    'LAST_NAME'             => $data['last_name'],
                    "ADDRESS"               => $data['billing']['address_1'].", ".$data['billing']['number']." ".$data['billing']['address_2'].", ".$data['billing']['neighborhood'].", ".$data['billing']['city']."/".$data['billing']['state'],
                    "UF_CRM_5EB94E418C162"  => $data['billing']['address_1'],
                    "UF_CRM_1643027746002"  => $data['billing']['number'],
                    'UF_CRM_1597844823179'  => $data['billing']['address_2'],
                    "UF_CRM_5EB94E419D72A"  => $data['billing']['neighborhood'],
                    "UF_CRM_5EB94E41ABB9F"  => $data['billing']['postcode'],
                    "UF_CRM_5EB94E41B300A"  => $data['billing']['city'],
                    "UF_CRM_5EB94E41BA1BF"  => getField('UF_CRM_5EB94E41BA1BF', $data['billing']['state'], 'contact', 0, MB_CASE_UPPER),
                    "UF_CRM_1672173391546"  => $data['id'],
                    "UF_CRM_1589202720035"  => $cpfBusca,
                    
                    
            );
        
        if($contact['total'] == 0){
            
            $oldPhones = array();
            $oldEmails = array();
            
            if(isset($data['billing']['phone']) && trim($data['billing']['phone']) != ''){
                $fields['PHONE'] = phonesUpdate($oldPhones, $data['billing']['phone']);
            }else{
                $fields['PHONE'] = $oldPhones;
            }
            
            if(isset($data['meta_data']['billing_cellphone']) && trim($data['meta_data']['billing_cellphone']) != ''){
                $fields['PHONE'] = phonesUpdate($fields['PHONE'], $data['meta_data']['billing_cellphone'], 'MOBILE');
            }
            
            // $fields['PHONE'] = phonesUpdate($fields['PHONE'], $data['meta_data']['billing_cellphone'], 'MOBILE');
            $fields['EMAIL'] = phonesUpdate($oldEmails, $data['billing']['email'], 'WORK', 'EMAIL');

            
            $contact['ID'] = addContact($fields, 1)['result'];
            

        }else{
            
            foreach($contact['result'] as $comKey => $comValue){
                
                if(isset($data['billing']['phone']) && trim($data['billing']['phone']) != ''){
                    $fields['PHONE'] = phonesUpdate($comValue['PHONE'], $data['billing']['phone']);
                }else{
                    $fields['PHONE'] = $comValue['PHONE'];
                }
                
                if(isset($data['meta_data']['billing_cellphone']) && trim($data['meta_data']['billing_cellphone']) != ''){
                    $fields['PHONE'] = phonesUpdate($fields['PHONE'], $data['meta_data']['billing_cellphone'], 'MOBILE');
                }

                // $fields['PHONE'] = phonesUpdate($oldPhones, $data['billing']['phone']);
                // $fields['PHONE'] = phonesUpdate($fields['PHONE'], $data['meta_data']['billing_cellphone'], 'MOBILE');
                $fields['EMAIL'] = phonesUpdate($comValue['EMAIL'], $data['billing']['email'], 'WORK', 'EMAIL');
                

                $contact['upd'] = updateContact($fields, $comValue['ID'], 1)['result'];
                
                printArray($contact);
                
                $contact['ID'] = $contact['result'][0]['ID'];
        
            }
        }
        
        
        updateStatus($value['id'], $db, 2, $value['obs'], 'OK - CONTACT: '.$contact['ID']);
        
        
        $mensagem = '[B]Dados do Contato Atualizados:[/B]
Cliente com dados atualizados vindos do E-Commerce.

'.arrayToString($fields);

        addFeed($contact['ID'], $mensagem, '3');

    }

}

        



















