<?php
header("Access-Control-Allow-Origin: *");
header('Cache-Control: no-cache, must-revalidate'); 
header("Content-Type: text/html; charset=UTF-8");
header("HTTP/1.1 200 OK");

date_default_timezone_set("America/Sao_Paulo");


/**
 * Write data to log file. (by default disabled)
 * WARNING: this method is only created for demonstration, never store log file in public folder
 *
 * @param mixed $data
 * @param string $title
 * @return bool
 */
function writeToLog($data, $title = '')
{

    $log = "\n------------------------\n";
    $log .= date("Y.m.d G:i:s")."\n";
    $log .= (strlen($title) > 0 ? $title : 'DEBUG')."\n";
    $log .= print_r($data, 1);
    $log .= "\n------------------------\n";

    file_put_contents(__DIR__."/endpointToDrupal.log", $log, FILE_APPEND);

    return true;
}

/* Mostrar de forma formatada os dados de um vetor */
function printArray($array){
    
    echo "<pre>";
    print_r($array);
    echo "</pre>";
    
}

function getRequestBd($request, $db){
    
    $dados = array();

    $sql = $db->prepare("SELECT * FROM bitrixToDrupal where data = :data");
    $sql->bindParam(":data", $request);
    $sql->execute();
    
    if($sql->rowCount() > 0){
        
        // echo "repetido";
        
        return false;

    }else{
        
        return true;
        
    }
    
}

/***********************************************************************/

writeToLog($_REQUEST, "REQUEST");

$jsonRequest = file_get_contents("php://input");

writeToLog($jsonRequest, "REQUEST Json");

if($_REQUEST['tkn'] != '2s0i5mi4wWiJO1q'){
    exit();
}

require "./conexao.php";

    $data = $_REQUEST; //json_decode($jsonRequest, 1);
    
    if(getRequestBd(serialize($data), $db)){
        
        $sql = $db->prepare("INSERT INTO bitrixToDrupal(data, obs) 
                                        VALUES (:data, :obs)");
        $serialize = serialize($data);
        $sql->bindParam(":data", $serialize);
        $sql->bindParam(":obs", serialize(array("Start")));

        $sql->execute();
        
        $return = array('result' => 'success',
                        'msg' => 'DATA RECEIVED');
        
        $json = json_encode($return, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE );
    
        echo $json;
        
    }else{
        
        $return = array('result' => 'success',
                        'msg' => 'DUPLICATED DATA');
        
        $json = json_encode($return, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE );
    
        echo $json;
        
    }






















